package com.ibm.rhapsody.sysML.proxyportWizards;

import java.util.Map;
import java.util.Vector;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;

import com.ibm.rhapsody.sysML.proxyportWizards.Utils.DirectionType;
import com.telelogic.rhapsody.core.IRPApplication;
import com.telelogic.rhapsody.core.IRPAttribute;
import com.telelogic.rhapsody.core.IRPClassifier;
import com.telelogic.rhapsody.core.IRPInstance;
import com.telelogic.rhapsody.core.IRPPort;

public class CreateProxyportPage extends WizardPage {
	private IRPClassifier block = null;
	private IRPInstance part = null;
	private IRPPort currentPort = null;
	
	private CreateProxyportComposite container;
	
	public CreateProxyportPage(IRPApplication rhapsody, IRPClassifier block, IRPInstance part, IRPPort currentPort) {
		super("CreateProxyportPageOf" + block.getName());
		
		this.block = block;
		this.part = part;
		this.currentPort = currentPort;
		if(block != null) {
			String title = "Expose properties of block via proxyport";
			setTitle(title);
		
			String description = "Choose the properties of block '" + block.getName();
			description += "' you want to expose via a proxyport";
			setDescription(description);
		}
		setPageComplete(false);
	}

	/**
	 * Create contents of the wizard.
	 * @param parent
	 */
	public void createControl(Composite parent) {
		container = new CreateProxyportComposite(parent, SWT.NONE, block, part, currentPort);
		setControl(container);
		
		setPageComplete(true);
	}
		
	public IRPPort createOrUpdateProxyport() {
		IRPPort port = null;
		if(container != null)
			port = container.createOrUpdateProxyport();
		return port;
	}
	
	public Vector<String> getInterfaceFlowPropertiesAsString(DirectionType direction) {
		Vector<String> interfaceAttrs = null;
		if(container != null)
			interfaceAttrs =  container.getInterfaceFlowPropertiesAsString(direction);
		return interfaceAttrs;
	}

	public Map<String, IRPAttribute> getInterfaceFlowPropertiesAsMap() {
		Map<String, IRPAttribute> attrMap = null;
		if(container != null)
			attrMap = container.getInterfaceFlowPropertiesAsMap();
		return attrMap;
	}
	
	public Map<String, IRPPort> getInterfacePortsAsMap() {
		Map<String, IRPPort> portMap = null;
		if(container != null)
			portMap = container.getInterfacePortsAsMap();
		return portMap;
	}
	
	public String getInterfaceName() {
		String interfaceName = null;
		if(container != null)
			interfaceName = container.getInterfaceName();
		return interfaceName;
	}
	
	public String getPortName() {
		String portName = null;
		if(container != null)
			portName = container.getPortName();
		return portName;
	}
	
	public IRPClassifier getInterfaceBlock() {
		IRPClassifier interfaceBlock = null;
		if(container != null)
			interfaceBlock =  container.getInterfaceBlock();
		return interfaceBlock;
	}
	
	public Map<String, DirectionType> getInterfaceFlowPropertiesDirectionMap() {
		Map<String, DirectionType> directionMap = null;
		if(container != null) {
			directionMap = container.getInterfaceFlowPropertiesDirectionMap();
		}
		return directionMap;
	}
}
